/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// CONQUEST OF TIBET:
// CREATED BY DANY:
// FEBRUARY 2008:

/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.01);
/*================================================================================================================*/
// ************************************* INITIALIZE THE MAP TYPE VARIABLES: ************************************* //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
  
        // THE MAP TYPE VARIABLES:
    	string nativeCiv1 = "Udasi";
        string nativeCiv2 = "Bhakti";
 
        string baseMix = "himalayas_b";
        string secondaryMix = "himalayas_a";
        string baseTerrain = "rockies\groundsnow6_roc";
        string cliffType = "himalayas";
        string cliffTerrain = "rockies\groundsnow6_roc";
 
        string denseForest = "Himalayas Forest";
        string sparseForest = "Himalayas Forest";
        string startTreeType = "ypTreeHimalayas";
  
        string mapType1 = "himalayas";
        string mapType2 = "grass";
  
        string tradeRouteType = "dirt";
		
		string riverType = "Yellow River";
		string seaType = "Coastal Japan";
		
		string whale1 = "HumpbackWhale";
  
        string fish1 = "ypFishCarp";
        string fish2 = "ypFishCatfish";
		  
        string huntable1 = "ypIbex";
        string huntable2 = "ypSerow";
  
        string herdable1 = "ypYak";
  
        string lightingType = "Himalayas";
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.05);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //  
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
	
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        subCiv0=rmGetCivID(nativeCiv1);
        rmEchoInfo("subCiv0 is "+nativeCiv1+ " " +subCiv0);
        if (subCiv0 >= 0)
        rmSetSubCiv(0, nativeCiv1);
    
        subCiv1=rmGetCivID(nativeCiv2);
        rmEchoInfo("subCiv1 is "+nativeCiv2+ " " +subCiv1);
        if (subCiv1 >= 0)
        rmSetSubCiv(1, nativeCiv2);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.10);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int playerTiles=40000;
        
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        // rmSetMapSize(size, size);
		   rmSetMapSize(800, 800);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.15);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/   
        
		// PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(0.0);

        // PICKS DEFAULT TERRAIN AND WATER:
        
		// SET MAP ELEVATION PARAMETERS:
		rmSetMapElevationParameters(cElevTurbulence, 0.02, -6, 0.5, 8.0);
		
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1);
		
		// SET SEA TYPE:
		// rmSetSeaType(riverType);
		   rmSetSeaType("Yellow River");
        
		// SET BASE TERRAIN MIX:
		// rmSetBaseTerrainMix(baseMix);
		   rmSetBaseTerrainMix("himalayas_b");
        
		// THE TERRAIN INITIALIZATION:
		// rmTerrainInitialize(baseTerrain, 6);
           rmTerrainInitialize("rockies\groundsnow6_roc", 6);		
    
        // SET THE LIGHTING:
		// rmSetLightingSet(lightingType);
		   rmSetLightingSet("Himalayas");
		   
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// SET THE MAP TYPE:
		// rmSetMapType(mapType1);
		   rmSetMapType("himalayas");
        // rmSetMapType(mapType2);
		   rmSetMapType("grass");
        rmSetMapType("water");
        
		// SET THE WORLD CIRCLE CONSTRAINT: (MAKE THE CORNERS:)
		rmSetWorldCircleConstraint(true);

        // CHOOSE THE MERCS:
		chooseMercs();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.20);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************************* DEFINE THE CONSTRAINTS: ****************************************** //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    
	// MAP EDGE CONSTRAINTS:
//	int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, 0, rmGetMapXSize()-18, 0, 0, 0);
//	int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
  	
	// PLAYER CONSTRAINTS:
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", rmClassID("player"), 8.0);
	
	// AVOID IMPASSABLE LAND:
    int impassableLandConstraint=rmCreateTerrainDistanceConstraint("stuff vs impassable land", "Land", false, 8.0);
  	
	// CARDINAL DIRECTIONS:
    int Northward=rmCreatePieConstraint("northMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
    int Southward=rmCreatePieConstraint("southMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
    int Westward=rmCreatePieConstraint("westMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
			
	// DECORATION AVOIDANCE:
    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0); 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE TRADE ROUTE: *************************************** //  
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		// TRADE ROUTE AVOIDANCE:
	    int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 6.0);
	    
	    // SOCKETS AVOIDANCE:
	    int avoidSocket=rmCreateTypeDistanceConstraint("stuff vs socket", "SocketTradeRoute", 12.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// TRADE ROUTE VARIATIONS:
		int whichTradeRoute=rmRandInt(1,2);
		
		// THE WEST TRADE ROUTE:
        int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("north trade route");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 8.0);
		
		if ( whichTradeRoute == 1 )
    {
        rmAddTradeRouteWaypoint(tradeRouteID, 0.30, 0.40);
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 0.70);
        rmAddTradeRouteWaypoint(tradeRouteID, 0.70, 0.60);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.30);
        rmAddTradeRouteWaypoint(tradeRouteID, 0.30, 0.40);
	}	
        else
	{
	    rmAddTradeRouteWaypoint(tradeRouteID, 0.175, 0.175);
	    //rmAddTradeRouteWaypoint(tradeRouteID, 0.250, 0.750);
        rmAddTradeRouteWaypoint(tradeRouteID, 0.500, 0.500);
		//rmAddTradeRouteWaypoint(tradeRouteID, 0.750, 0.250);
        rmAddTradeRouteWaypoint(tradeRouteID, 0.825, 0.825);
	}

     	bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "water");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
        if ( whichTradeRoute == 1 )
	{	
		// ADD THE SOCKETS ALONG THE TRADE ROUTE:
		rmPlaceObjectDefAtLoc(socketID, 0, 0.30, 0.40);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.60, 0.70);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.70, 0.60);
		rmPlaceObjectDefAtLoc(socketID, 0, 0.40, 0.30);
	}	
	    else
    {		
		// ADD THE SOCKETS ALONG THE TRADE ROUTE:
		vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.020);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.25);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
  
        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.5);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.75);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, .980);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.30);
/*================================================================================================================*/
// ****************************************** CHECK FOR KOTH GAME MODE: ***************************************** //  
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int avoidKOTH=rmCreateTypeDistanceConstraint("avoid KOTH", "ypKingsHill", 12.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		if(rmGetIsKOTH()) 
    {
    
        int randLoc = rmRandInt(1,2);
        float xLoc = 0.5;
        float yLoc = 0.5;
        float walk = 0.075;
    
        if(randLoc == 1 || cNumberTeams > 2)
        yLoc = .5;
    
        else
        yLoc = .5;
    
        ypKingsHillPlacer(xLoc, xLoc, walk, avoidSocket);
      	//ypKingsHillPlacer(xLoc, yLoc, walk, 0);
        rmEchoInfo("XLOC = "+xLoc);
        rmEchoInfo("XLOC = "+yLoc);
    }	
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.30);
/*================================================================================================================*/
// *************************************** DEFINE THE AREAS OF THE MAP: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*
        // PJJ - BUILD UP OUTER CLIFF AREA:
        int outerCliff=rmCreateArea("Outer Cliffs");
        rmSetAreaSize(outerCliff, 1.0, 1.0);
        rmSetAreaWarnFailure(outerCliff, false);
        rmSetAreaSmoothDistance(outerCliff, 10);
        
		// rmSetAreaMix(outerCliff, baseMix);
		   rmSetAreaMix(outerCliff, "himalayas_b");
        
		
		rmSetAreaCoherence(outerCliff, 1);
        rmSetAreaLocation(outerCliff, 0.5, 0.5);
        
		// rmSetAreaCliffType(outerCliff, cliffType);
		   rmSetAreaCliffType(outerCliff, "himalayas");
        
		rmSetAreaCliffEdge(outerCliff, 1, 1.0, 1.0, 0.0, 0);
        rmSetAreaCliffHeight(outerCliff, -4, 1.0, 0.3);
        //~ rmSetAreaTerrainType(outerCliff, "rockies\groundsnow6_roc");
        rmSetAreaCliffPainting(outerCliff, true, true, true);
        rmAddAreaToClass(outerCliff, classTop);
        rmBuildArea(outerCliff);
*/		
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*  
        // REPAINT THE GROUND:
		int paintGround=rmCreateArea("repaint the ground", outerCliff);
        rmSetAreaSize(paintGround, 1.0, 1.0);
        rmSetAreaWarnFailure(paintGround, false);
        rmSetAreaSmoothDistance(paintGround, 10);
        rmSetAreaCoherence(paintGround, 1);
        rmSetAreaLocation(paintGround, 0.5, 0.5);
        
		// rmSetAreaMix(paintGround, baseMix);
		   rmSetAreaMix(paintGround, "himalayas_b");
		
		rmAddAreaToClass(paintGround, classTop);
        rmBuildArea(paintGround);
*/		
/*----------------------------------------------------------------------------------------------------------------*/
  
        // THE DEFINITION OF A VARIABLE NEEDED LATER:
		//int i = 0;
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************* SET UP PLAYER STARTING LOCATIONS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        float teamSide = rmRandFloat(0, 1);
		
	    if (cNumberTeams == 2)	
{
    
        if (teamSide > .5) 
	{
        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.625, 0.825, 0.825, 0.625, 0.0, 0.0);

        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.375, 0.175, 0.175, 0.375, 0.0, 0.0);
    }
    
        else 
	{
        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.375, 0.175, 0.175, 0.375, 0.0, 0.);

        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.625, 0.825, 0.825, 0.625, 0.0, 0.);
    }
}
  
	    else	
{
	    rmSetTeamSpacingModifier(0.75);
	    rmPlacePlayersCircular(0.4, 0.4, 0);
}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.40);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** //	
/*================================================================================================================*/  
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
  
        // SET UP VALLEYS FOR EACH PLAYER:
 
        int i = 0;
        int id = 0;
        int startingRidge = 0;
        		
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
 
        float playerFraction=rmAreaTilesToFraction(3250);
		
		for(i=1; < cNumberPlayers)
	{
        // CREATE THE AREA:
        id=rmCreateArea("Player"+i);

        // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);

        // - SET THE SIZE AND AREA PARAMETERS: -
        
		// SET AREA SIZE:
		rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
		
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");

		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "texas_dirt");
		
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_grass");
	    
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
       
		// BUILD AREA:
		rmBuildArea(id);
  }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.45);
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
  
   // PLACEMENT ORDER:
   // NATIVES -> RIDGES -> RESOURCES -> NUGGETS:
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.50);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NATIVES: **************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int nativesClass=rmDefineClass("natives");
	    int nativesConstraint=rmCreateClassDistanceConstraint("stuff vs natives", rmClassID("natives"), 15.0);
	    int importantItemClass=rmDefineClass("importantItem");
	    int importantItemConstraint=rmCreateClassDistanceConstraint("stuff vs importantItem", rmClassID("importantItem"), 15.0);

/*----------------------------------------------------------------------------------------------------------------*/
		
		int lakotaVillageAID = -1;
        int lakotaVillageType = rmRandInt(1,5);
        
		// lakotaVillageAID = rmCreateGrouping("village 1A", "native " +nativeCiv1+ " village himal "+lakotaVillageType);
           lakotaVillageAID = rmCreateGrouping("village 1A", "native udasi village himal "+lakotaVillageType);
       
		rmSetGroupingMinDistance(lakotaVillageAID, 0.0);
        rmSetGroupingMaxDistance(lakotaVillageAID, 0.0);
        
		rmAddGroupingToClass(lakotaVillageAID, rmClassID("importantItem"));
		rmAddGroupingToClass(lakotaVillageAID, rmClassID("natives"));
		
		//rmAddGroupingConstraint(lakotaVillageAID, nativesConstraint);
                
		rmPlaceGroupingAtLoc(lakotaVillageAID, 0, 0.175, 0.825);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		int lakotaVillageBID = -1;
        lakotaVillageType = rmRandInt(1,5);
        
		// lakotaVillageBID = rmCreateGrouping("village 1B", "native " +nativeCiv2+ " village himal "+lakotaVillageType);
           lakotaVillageBID = rmCreateGrouping("village 1B", "native Bhakti village himal "+lakotaVillageType);
       
		
		rmSetGroupingMinDistance(lakotaVillageBID, 0.0);
        rmSetGroupingMaxDistance(lakotaVillageBID, 0.0);
		rmAddGroupingToClass(lakotaVillageBID, rmClassID("importantItem"));
		rmAddGroupingToClass(lakotaVillageBID, rmClassID("natives"));
        
        //rmAddGroupingConstraint(lakotaVillageBID, nativesConstraint);
                
		rmPlaceGroupingAtLoc(lakotaVillageBID, 0, 0.825, 0.175);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int lakotaVillageCID = -1;
        lakotaVillageType = rmRandInt(1,5);
        
		// lakotaVillageCID = rmCreateGrouping("village 1C", "native " +nativeCiv1+ " village himal "+lakotaVillageType);
           lakotaVillageCID = rmCreateGrouping("village 1C", "native udasi village himal "+lakotaVillageType);
       
		rmSetGroupingMinDistance(lakotaVillageCID, 0.0);
        rmSetGroupingMaxDistance(lakotaVillageCID, 0.0);
        
		rmAddGroupingToClass(lakotaVillageCID, rmClassID("importantItem"));
		rmAddGroupingToClass(lakotaVillageCID, rmClassID("natives"));
		
		//rmAddGroupingConstraint(lakotaVillageCID, nativesConstraint);
                
		rmPlaceGroupingAtLoc(lakotaVillageCID, 0, 0.450, 0.850);

/*----------------------------------------------------------------------------------------------------------------*/

        int lakotaVillageDID = -1;
        lakotaVillageType = rmRandInt(1,5);
        
		// lakotaVillageDID = rmCreateGrouping("village 1D", "native " +nativeCiv2+ " village himal "+lakotaVillageType);
           lakotaVillageDID = rmCreateGrouping("village 1D", "native Bhakti village himal "+lakotaVillageType);
       
		
		rmSetGroupingMinDistance(lakotaVillageDID, 0.0);
        rmSetGroupingMaxDistance(lakotaVillageDID, 0.0);
		rmAddGroupingToClass(lakotaVillageDID, rmClassID("importantItem"));
		rmAddGroupingToClass(lakotaVillageDID, rmClassID("natives"));
        
        //rmAddGroupingConstraint(lakotaVillageDID, nativesConstraint);
                
		rmPlaceGroupingAtLoc(lakotaVillageDID, 0, 0.150, 0.550);

/*----------------------------------------------------------------------------------------------------------------*/
        
		int lakotaVillageEID = -1;
        lakotaVillageType = rmRandInt(1,5);
        
		// lakotaVillageEID = rmCreateGrouping("village 1E", "native " +nativeCiv1+ " village himal "+lakotaVillageType);
           lakotaVillageEID = rmCreateGrouping("village 1E", "native udasi village himal "+lakotaVillageType);
       
		rmSetGroupingMinDistance(lakotaVillageEID, 0.0);
        rmSetGroupingMaxDistance(lakotaVillageEID, 0.0);
        
		rmAddGroupingToClass(lakotaVillageEID, rmClassID("importantItem"));
		rmAddGroupingToClass(lakotaVillageEID, rmClassID("natives"));
		
		//rmAddGroupingConstraint(lakotaVillageEID, nativesConstraint);
                
		rmPlaceGroupingAtLoc(lakotaVillageEID, 0, 0.550, 0.150);

/*----------------------------------------------------------------------------------------------------------------*/

        int lakotaVillageFID = -1;
        lakotaVillageType = rmRandInt(1,5);
        
		// lakotaVillageFID = rmCreateGrouping("village 1F", "native " +nativeCiv2+ " village himal "+lakotaVillageType);
           lakotaVillageFID = rmCreateGrouping("village 1F", "native Bhakti village himal "+lakotaVillageType);
       
		
		rmSetGroupingMinDistance(lakotaVillageFID, 0.0);
        rmSetGroupingMaxDistance(lakotaVillageFID, 0.0);
		rmAddGroupingToClass(lakotaVillageFID, rmClassID("importantItem"));
		rmAddGroupingToClass(lakotaVillageFID, rmClassID("natives"));
        
        //rmAddGroupingConstraint(lakotaVillageFID, nativesConstraint);
                
		rmPlaceGroupingAtLoc(lakotaVillageFID, 0, 0.850, 0.450);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.55);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE LAKES: ***************************************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        
		int classLake=rmDefineClass("lake");
		int lakeConstraint=rmCreateClassDistanceConstraint("stuff vs. lake", rmClassID("lake"), 15.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE WESTERN LAKE:
		int lakeID=rmCreateArea("The Western Lake");
		
		rmSetAreaLocation(lakeID, 0.3, 0.7);
		
		rmSetAreaSize(lakeID, rmAreaTilesToFraction(6500), rmAreaTilesToFraction(6500));
		
		rmSetAreaObeyWorldCircleConstraint(lakeID, false);
		rmSetAreaCoherence(lakeID, 0.65);
        rmSetAreaWaterType(lakeID, "great lakes");
	    rmSetAreaBaseHeight(lakeID, 1.0);
	    
		rmSetAreaMinBlobs(lakeID, 5);
	    rmSetAreaMaxBlobs(lakeID, 5);
	    rmSetAreaMinBlobDistance(lakeID, 10.0);
	    rmSetAreaMaxBlobDistance(lakeID, 20.0);
		
		rmAddAreaConstraint(lakeID, nativesConstraint);
	    
		rmAddAreaToClass(lakeID, classLake);
	    rmSetAreaWarnFailure(lakeID, false);

        rmBuildArea(lakeID);

/*----------------------------------------------------------------------------------------------------------------*/
		
	    // THE EASTERN LAKE:
		int lake2ID=rmCreateArea("The Eastern Lake");
		
		rmSetAreaLocation(lake2ID, 0.7, 0.3);
		
		rmSetAreaSize(lake2ID, rmAreaTilesToFraction(6500), rmAreaTilesToFraction(6500));
		
		rmSetAreaObeyWorldCircleConstraint(lake2ID, false);
		rmSetAreaCoherence(lake2ID, 0.65);
        rmSetAreaWaterType(lake2ID, "great lakes");
	    rmSetAreaBaseHeight(lake2ID, 1.0);
	    
		rmSetAreaMinBlobs(lake2ID, 5);
	    rmSetAreaMaxBlobs(lake2ID, 5);
	    rmSetAreaMinBlobDistance(lake2ID, 10.0);
	    rmSetAreaMaxBlobDistance(lake2ID, 20.0);
		
		rmAddAreaConstraint(lake2ID, nativesConstraint);
	    
		rmAddAreaToClass(lake2ID, classLake);
	    rmSetAreaWarnFailure(lake2ID, false);

        rmBuildArea(lake2ID);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE RIDGES: - (CLIFFS) - ********************************** // 
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/


        float edgeCliffCoherence = .9;
        float midCliffCoherence = .55;

/*----------------------------------------------------------------------------------------------------------------*/		

        // - BUILD RIDGES WITH RIDGE AVOIDANCE TO START A BASIC TOPOGRAPHY: -
	
    int classStartingRidge = rmDefineClass("startingRidge");
	int ridgeAvoidsRidge = rmCreateClassDistanceConstraint("ridges vs other ridges", rmClassID("startingRidge"), 20.0);
    int ridgeAvoidImpassableLand=rmCreateTerrainDistanceConstraint("ridges vs impassable land", "Land", false, 12.0);
    int ridgeConstraint=rmCreateClassDistanceConstraint("stuff vs ridge", rmClassID("startingRidge"), 15.0);
		
		int randomRidge = 5; 
        float ridgeHeightVariance = 1.5;
        int ridgeAvoid = 3;  
        int numTries = -1;
        int failCount = -1;
		
		if (cNumberNonGaiaPlayers <=2)
        int extraRidges = 6 + cNumberNonGaiaPlayers*8;
		else
		extraRidges = 6 + cNumberNonGaiaPlayers*4;
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        for(i=0; < extraRidges) 
{
        if(rmRandInt(1,5) <= randomRidge) 
	{
        startingRidge=rmCreateArea("Ridge 11"+i);
        
		rmAddAreaConstraint(startingRidge, playerConstraint); 
        rmAddAreaConstraint(startingRidge, playerEdgeConstraint);
        rmAddAreaConstraint(startingRidge, ridgeAvoidsRidge);
        rmAddAreaConstraint(startingRidge, avoidTradeRoute);
        rmAddAreaConstraint(startingRidge, avoidSocket);
		rmAddAreaConstraint(startingRidge, avoidKOTH);
        rmAddAreaConstraint(startingRidge, ridgeAvoidImpassableLand);
        rmAddAreaConstraint(startingRidge, nativesConstraint);     
    
        rmSetAreaSize(startingRidge, rmAreaTilesToFraction(125), rmAreaTilesToFraction(150));
        rmSetAreaWarnFailure(startingRidge, false);
        rmSetAreaCoherence(startingRidge, midCliffCoherence);
        //~ rmSetAreaTerrainType(startingRidge, cliffTerrain);
        rmSetAreaCliffType(startingRidge, cliffType);
        rmSetAreaCliffEdge(startingRidge, 1, 1.0, 1.0, 0.0, 0);
        rmSetAreaCliffHeight(startingRidge, 5, ridgeHeightVariance, 0.3);
        rmSetAreaCliffPainting(startingRidge, true, false, true, 0, true);
        rmAddAreaToClass(startingRidge, classStartingRidge);
      
        if(rmBuildArea(startingRidge)==false)
	  {
        failCount++;
        if(failCount==5) // Stop trying once we fail 5 times in a row.
        break;
      }
        else
        failCount=0;
    }
}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.65);
/*================================================================================================================*/
// ******** BEGIN SMALLER RIDGES WITH LOWER % CHANCE TO SPAWN AND POSSIBLY NO RIDGE AVOIDANCE CONSTRAINT: ******* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        randomRidge = 4;
        ridgeAvoid = 5; 
        numTries = -1;
        failCount = -1;
		
        if (cNumberNonGaiaPlayers <=2)
		extraRidges = 6 + cNumberNonGaiaPlayers*8;
		else
		extraRidges = 6 + cNumberNonGaiaPlayers*4;
		
/*----------------------------------------------------------------------------------------------------------------*/		

        for(i=0; < extraRidges) 
{
    
        if(rmRandInt(1,5) <= randomRidge) 
	{
        startingRidge=rmCreateArea("Ridge 31"+i);
        rmAddAreaConstraint(startingRidge, playerConstraint); 
		rmAddAreaConstraint(startingRidge, playerEdgeConstraint); 
        rmAddAreaConstraint(startingRidge, ridgeAvoidImpassableLand);
        rmAddAreaConstraint(startingRidge, nativesConstraint);   
        rmAddAreaConstraint(startingRidge, avoidTradeRoute);
        rmAddAreaConstraint(startingRidge, avoidSocket);
		rmAddAreaConstraint(startingRidge, avoidKOTH);
        rmAddAreaConstraint(startingRidge, ridgeAvoidsRidge);
  
        rmSetAreaSize(startingRidge, rmAreaTilesToFraction(50), rmAreaTilesToFraction(75));
        rmSetAreaWarnFailure(startingRidge, false);
        rmSetAreaCoherence(startingRidge, midCliffCoherence);
        //~ rmSetAreaTerrainType(startingRidge, cliffTerrain);
        rmSetAreaCliffType(startingRidge, cliffType);
        rmSetAreaCliffEdge(startingRidge, 1, 1.0, 1.0, 0.0, 0);
        rmSetAreaCliffHeight(startingRidge, 5, ridgeHeightVariance, 0.3);
        rmSetAreaCliffPainting(startingRidge, true, false, true, 0, true);
        rmAddAreaToClass(startingRidge, classStartingRidge);
      
        if(rmBuildArea(startingRidge)==false)
	  {
        failCount++;
        if(failCount==5) // Stop trying once we fail 5 times in a row.
        break;
      }
        else
        failCount=0;
    }
}
  
        failCount = -1;

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************ DEFINE THE STARTING TCID AND STARTING UNITS AND RESOURCES: ************************** //  
/*================================================================================================================*/
  
    // THE STARTING UNIT CLASS:
	int classStartingUnit=rmDefineClass("startingUnit");
		
	// THE STARTING UNIT AVOIDANCE:
	int startingUnitsConstraint=rmCreateClassDistanceConstraint("stuff vs starting units", rmClassID("startingUnit"), 8.0);
    
    // FRUITS AVOIDANCE:
	int fruitsConstraint=rmCreateTypeDistanceConstraint("stuff vs fruits", "AbstractFruit", 15.0);
	int fruitsMediumConstraint=rmCreateTypeDistanceConstraint("medium vs fruits", "AbstractFruit", 35.0);
	int fruitsFarConstraint=rmCreateTypeDistanceConstraint("far vs fruits", "AbstractFruit", 65.0);
	 
	// COIN AVOIDANCE:
	int coinConstraint=rmCreateTypeDistanceConstraint("stuff vs coin", "AbstractMine", 15.0);
	int coinMediumConstraint=rmCreateTypeDistanceConstraint("medium vs coin", "AbstractMine", 35.0);
	int coinFarConstraint=rmCreateTypeDistanceConstraint("far vs coin", "AbstractMine", 65.0);
	
	// YPIBEX AVOIDANCE:
	int ypIbexConstraint=rmCreateTypeDistanceConstraint("stuff vs ypIbex", "ypIbex", 15.0);
	int ypIbexMediumConstraint=rmCreateTypeDistanceConstraint("medium vs ypIbex", "ypIbex", 35.0);
	int ypIbexFarConstraint=rmCreateTypeDistanceConstraint("far vs ypIbex", "ypIbex", 65.0);
	
	// THE NUGGETS CLASS:
	int classNugget=rmDefineClass("nugget");
		
	// THE NUGGETS AVOIDANCE:
	int nuggetConstraint=rmCreateClassDistanceConstraint("stuff vs nugget", rmClassID("nugget"), 15.0);
	int nuggetMediumConstraint=rmCreateClassDistanceConstraint("medium vs nugget", rmClassID("nugget"), 35.0);
	int nuggetFarConstraint=rmCreateClassDistanceConstraint("far vs nugget", rmClassID("nugget"), 65.0);
	
	// THE TREES CLASS:
	int classTree=rmDefineClass("tree");
		
	// THE TREES AVOIDANCE:
	int treeConstraint=rmCreateClassDistanceConstraint("stuff vs tree", rmClassID("tree"), 8.0);
    int treeMediumConstraint=rmCreateClassDistanceConstraint("medium vs tree", rmClassID("tree"), 25.0);
    int treeFarConstraint=rmCreateClassDistanceConstraint("far vs tree", rmClassID("tree"), 65.0);
	
	// FLAG CONSTRAINTS:
    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
	int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	// int flagEdgeConstraint=rmCreatePieConstraint("flag edge of map", 0.5, 0.5, 0, rmGetMapXSize()-10, 0, 0, 0);

  	
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE STARTING TCID:
        int startingTCID= rmCreateObjectDef("startingTC");
        if ( rmGetNomadStart())
    {
        rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
    }
        else
    {
        rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
    }
        rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(startingTCID, 0.0);
        rmSetObjectDefMaxDistance(startingTCID, 0.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
		rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
        rmAddObjectDefConstraint(startingUnits, startingUnitsConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/

		int playerCrateID=rmCreateObjectDef("bonus starting crates");
        rmAddObjectDefItem(playerCrateID, "crateOfFood", 2, 4.0);
        rmAddObjectDefItem(playerCrateID, "crateOfWood", 1, 0.0);
        rmAddObjectDefItem(playerCrateID, "crateOfCoin", 1, 0.0);
		rmAddObjectDefToClass(playerCrateID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerCrateID, 5);
        rmSetObjectDefMaxDistance(playerCrateID, 14);
	    rmAddObjectDefConstraint(playerCrateID, startingUnitsConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE PLAYER BERRY:
		int playerBerryID=rmCreateObjectDef("player berries");
        rmAddObjectDefItem(playerBerryID, "berryBush", 5, 4.0);
		rmAddObjectDefToClass(playerBerryID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerBerryID, 16);
        rmSetObjectDefMaxDistance(playerBerryID, 25);
	    rmAddObjectDefConstraint(playerBerryID, startingUnitsConstraint);
        rmAddObjectDefConstraint(playerBerryID, fruitsMediumConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE PLAYER GOLD:
		int playerGoldID = rmCreateObjectDef("player silver closer "+i);
        rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		rmAddObjectDefToClass(playerGoldID, rmClassID("startingUnit"));
		rmSetObjectDefMinDistance(playerGoldID, 16.0);
        rmSetObjectDefMaxDistance(playerGoldID, 25.0);	
        rmAddObjectDefConstraint(playerGoldID, startingUnitsConstraint);
        rmAddObjectDefConstraint(playerGoldID, fruitsConstraint);
		rmAddObjectDefConstraint(playerGoldID, coinMediumConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        // DEFINE THE START YPIBEX:
		int StartYpIbexID=rmCreateObjectDef("The Starting YpIbex");
        // rmAddObjectDefItem(StartYpIbexID, huntable1, 12, 10.0);
		   rmAddObjectDefItem(StartYpIbexID, "ypIbex", 12, 10.0);
        rmSetObjectDefMinDistance(StartYpIbexID, 18.0);
        rmSetObjectDefMaxDistance(StartYpIbexID, 25.0);
        rmSetObjectDefCreateHerd(StartYpIbexID, false);
        rmAddObjectDefConstraint(StartYpIbexID, startingUnitsConstraint);
        rmAddObjectDefConstraint(StartYpIbexID, fruitsConstraint);
		rmAddObjectDefConstraint(StartYpIbexID, coinConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
        rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
        rmAddObjectDefToClass(playerNuggetID, rmClassID("nugget"));
        rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 20.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
        rmAddObjectDefConstraint(playerNuggetID, startingUnitsConstraint);
        rmAddObjectDefConstraint(playerNuggetID, fruitsConstraint);
		rmAddObjectDefConstraint(playerNuggetID, coinConstraint);
		rmAddObjectDefConstraint(playerNuggetID, nuggetMediumConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE START AREA TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
        // rmAddObjectDefItem(StartAreaTreeID, startTreeType, 8, 6.0);
		   rmAddObjectDefItem(StartAreaTreeID, "ypTreeHimalayas", 10, 8.0);
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));   
		rmAddObjectDefToClass(StartAreaTreeID, rmClassID("tree"));   
        rmSetObjectDefMinDistance(StartAreaTreeID, 32.0);
        rmSetObjectDefMaxDistance(StartAreaTreeID, 40.0);
        rmAddObjectDefConstraint(StartAreaTreeID, startingUnitsConstraint);
        rmAddObjectDefConstraint(StartAreaTreeID, nuggetConstraint);
        rmAddObjectDefConstraint(StartAreaTreeID, fruitsConstraint);
		rmAddObjectDefConstraint(StartAreaTreeID, coinConstraint);
		rmAddObjectDefConstraint(StartAreaTreeID, treeMediumConstraint);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE VARIABLE FOR WATER SPAWN POINT:
		int waterSpawnPointID = 0;		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************* PLACE THE STARTING TCID AND STARTING UNITS AND RESOURCES: ************************** //
/*================================================================================================================*/    
    
	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
		
		for(i=1; <cNumberPlayers) 
	{
        // PLACE THE STARTING TCID AND STARTING UNITS:
		//rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        //rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE TCID AND STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));				
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		// PLACE THE PLAYER CRATES:
		rmPlaceObjectDefAtLoc(playerCrateID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        // PLACE THE PLAYER BERRY:
		rmPlaceObjectDefAtLoc(playerBerryID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(playerBerryID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE START YPIBEX:
		rmPlaceObjectDefAtLoc(StartYpIbexID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE A NUGGET FOR THE PLAYER:
        rmSetNuggetDifficulty(1, 1);
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

        rmSetNuggetDifficulty(2, 2);
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING TREES:
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE WATER SPAWN POINTS:
		waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 10.0);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
        //rmAddClosestPointConstraint(flagEdgeConstraint);
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
     
        // PLACE A CARAVEL:
		int catamaranID=rmCreateObjectDef("Caravel"+i);
        rmAddObjectDefItem(catamaranID, "Caravel", 1, 0.0);
        rmPlaceObjectDefAtLoc(catamaranID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
	
	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();

    }
  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/   
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int forestClass=rmDefineClass("classForest");
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 15.0);
	    int forestMediumConstraint=rmCreateClassDistanceConstraint("medium vs. forest", rmClassID("classForest"), 65.0);

/*----------------------------------------------------------------------------------------------------------------*/
		
		int forestTreeID = 0;
		failCount=0;
  
        if (cNumberNonGaiaPlayers <=2)
		numTries = 8 * cNumberNonGaiaPlayers;
		else
		numTries = 4 * cNumberNonGaiaPlayers;
	
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NORTHERN FORESTS:
		for (i=0; <numTries) 
{   
        int northForest = rmCreateArea("The Northern Forest"+i);
        rmSetAreaWarnFailure(northForest, false);
        rmSetAreaSize(northForest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(350));
        rmAddAreaToClass(northForest, rmClassID("classForest"));
        
		// rmSetAreaForestType(northForest, denseForest);
		   rmSetAreaForestType(northForest, "Himalayas Forest");
        
		rmSetAreaForestDensity(northForest, 0.65);
        rmSetAreaForestClumpiness(northForest, 0.55);
        rmSetAreaForestUnderbrush(northForest, 0.0);
        rmSetAreaCoherence(northForest, 0.3);
        rmSetAreaSmoothDistance(northForest, 10);
        rmSetAreaObeyWorldCircleConstraint(northForest, false);
        
		rmAddAreaConstraint(northForest, playerConstraint);		
        rmAddAreaConstraint(northForest, playerEdgeConstraint);	
        rmAddAreaConstraint(northForest, forestMediumConstraint);			
        rmAddAreaConstraint(northForest, ridgeConstraint);
		rmAddAreaConstraint(northForest, avoidKOTH);
		rmAddAreaConstraint(northForest, Northward);
        rmAddAreaConstraint(northForest, avoidTradeRoute);
        rmAddAreaConstraint(northForest, avoidSocket);
        rmAddAreaConstraint(northForest, nativesConstraint);
		rmAddAreaConstraint(northForest, impassableLandConstraint);
		
        if(rmBuildArea(northForest) == false) 
	{
        // Stop trying once we fail 4 times in a row.
        failCount++;
        if(failCount==4)
        break;
    }
        else
        failCount=0; 
}
        failCount=0; 
		
/*----------------------------------------------------------------------------------------------------------------*/		
  
        // THE SOUTHERN FORESTS:
		for (i=0; <numTries) 
{   
        int southForest = rmCreateArea("The Southern Forest"+i);
        rmSetAreaWarnFailure(southForest, false);
        rmSetAreaSize(southForest, rmAreaTilesToFraction(175), rmAreaTilesToFraction(350));
        rmAddAreaToClass(southForest, rmClassID("classForest"));
        
		// rmSetAreaForestType(southForest, sparseForest);
		   rmSetAreaForestType(southForest, "Himalayas Forest");
	
		rmSetAreaForestDensity(southForest, 0.3);
        rmSetAreaForestClumpiness(southForest, 0.2);
        rmSetAreaForestUnderbrush(southForest, 0.0);
        rmSetAreaCoherence(southForest, 0.3);
        rmSetAreaSmoothDistance(southForest, 10);
        rmSetAreaObeyWorldCircleConstraint(southForest, false);
        
		rmAddAreaConstraint(southForest, playerConstraint);		
        rmAddAreaConstraint(southForest, playerEdgeConstraint);	
        rmAddAreaConstraint(southForest, forestMediumConstraint);			
        rmAddAreaConstraint(southForest, ridgeConstraint);
		rmAddAreaConstraint(southForest, avoidKOTH);
		rmAddAreaConstraint(southForest, Southward);
        rmAddAreaConstraint(southForest, avoidTradeRoute);
        rmAddAreaConstraint(southForest, avoidSocket);
        rmAddAreaConstraint(southForest, nativesConstraint);
		rmAddAreaConstraint(southForest, impassableLandConstraint);
    
        if(rmBuildArea(southForest) == false) 
	{
        // Stop trying once we fail 4 times in a row.
        failCount++;
        if(failCount==4)
        break;
    }
        else
        failCount=0; 
}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME RANDOM GOLD: ************************************* //
/*================================================================================================================*/
	
		// GOLD MINES CONSTRAINTS:
	    int goldConstraint=rmCreateTypeDistanceConstraint("the stuff vs gold", "AbstractMine", 15.0);
		int goldMediumConstraint=rmCreateTypeDistanceConstraint("The medium vs gold", "AbstractMine", 40.0);
	    int goldFarConstraint=rmCreateTypeDistanceConstraint("the far vs gold", "AbstractMine", 65.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
		
		// THE RANDOM NORTHERN GOLD:
		int goldID = rmCreateObjectDef("The Northern Random Gold");
	    rmAddObjectDefItem(goldID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(goldID, 0.0);
	    rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(goldID, goldFarConstraint);
		rmAddObjectDefConstraint(goldID, avoidAll);
		rmAddObjectDefConstraint(goldID, avoidKOTH);
		rmAddObjectDefConstraint(goldID, avoidTradeRoute);
		rmAddObjectDefConstraint(goldID, avoidSocket);
		rmAddObjectDefConstraint(goldID, forestConstraint);
		rmAddObjectDefConstraint(goldID, nativesConstraint);
		rmAddObjectDefConstraint(goldID, playerConstraint);
		rmAddObjectDefConstraint(goldID, playerEdgeConstraint);
		rmAddObjectDefConstraint(goldID, ridgeConstraint);
		rmAddObjectDefConstraint(goldID, Northward);
		rmAddObjectDefConstraint(goldID, impassableLandConstraint);
			
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(goldID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
    } 
	
/*----------------------------------------------------------------------------------------------------------------*/
        
		// THE RANDOM SOUTHERN GOLD:
		int gold2ID = rmCreateObjectDef("The Southern Random Gold");
	    rmAddObjectDefItem(gold2ID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(gold2ID, 0.0);
	    rmSetObjectDefMaxDistance(gold2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(gold2ID, goldFarConstraint);
		rmAddObjectDefConstraint(gold2ID, avoidAll);
		rmAddObjectDefConstraint(gold2ID, avoidKOTH);
		rmAddObjectDefConstraint(gold2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(gold2ID, avoidSocket);
		rmAddObjectDefConstraint(gold2ID, forestConstraint);
		rmAddObjectDefConstraint(gold2ID, nativesConstraint);
		rmAddObjectDefConstraint(gold2ID, playerConstraint);
		rmAddObjectDefConstraint(gold2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(gold2ID, ridgeConstraint);
		rmAddObjectDefConstraint(gold2ID, Southward);
		rmAddObjectDefConstraint(gold2ID, impassableLandConstraint);
	
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(gold2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0);
    }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    // NUGGET CONSTRAINTS:
	    //int nuggetConstraint=rmCreateTypeDistanceConstraint("the stuff vs nugget", "AbstractNugget", 15.0);
		//int nuggetMediumConstraint=rmCreateTypeDistanceConstraint("The medium vs nugget", "AbstractNugget", 25.0);
	    //int nuggetFarConstraint=rmCreateTypeDistanceConstraint("the far vs nugget", "AbstractNugget", 65.0);
		
        // THE NUGGETS AVOIDANCE:
	    //int nuggetConstraint=rmCreateClassDistanceConstraint("stuff vs nugget", rmClassID("nugget"), 8.0);
	    //int nuggetMediumConstraint=rmCreateClassDistanceConstraint("medium vs nugget", rmClassID("nugget"), 35.0);
	    //int nuggetFarConstraint=rmCreateClassDistanceConstraint("far vs nugget", rmClassID("nugget"), 65.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN EASY NUGGETS:
	    int nugget1= rmCreateObjectDef("The Northern Easy Nugget"); 
	    rmAddObjectDefItem(nugget1, "Nugget", 1, 0.0);
		rmAddObjectDefToClass(nugget1, rmClassID("nugget"));
	    rmSetNuggetDifficulty(1, 3);
	    rmSetObjectDefMinDistance(nugget1, 0.0);
	    rmSetObjectDefMaxDistance(nugget1, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget1, nuggetFarConstraint);
		rmAddObjectDefConstraint(nugget1, avoidAll);
		rmAddObjectDefConstraint(nugget1, Northward);
		rmAddObjectDefConstraint(nugget1, forestConstraint);
		rmAddObjectDefConstraint(nugget1, goldConstraint);
		rmAddObjectDefConstraint(nugget1, avoidSocket);
		rmAddObjectDefConstraint(nugget1, avoidTradeRoute);
	    rmAddObjectDefConstraint(nugget1, ridgeConstraint);
	    rmAddObjectDefConstraint(nugget1, nativesConstraint);
        rmAddObjectDefConstraint(nugget1, playerConstraint);
		rmAddObjectDefConstraint(nugget1, playerEdgeConstraint);
		rmAddObjectDefConstraint(nugget1, avoidKOTH);
		rmAddObjectDefConstraint(nugget1, impassableLandConstraint);
				   
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(nugget1, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);
	}
        else
	{
        rmPlaceObjectDefAtLoc(nugget1, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
	}

/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN EASY NUGGETS:
	    int nugget2= rmCreateObjectDef("The southern Easy Nugget"); 
	    rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
		rmAddObjectDefToClass(nugget2, rmClassID("nugget"));
	    rmSetNuggetDifficulty(1, 3);
	    rmSetObjectDefMinDistance(nugget2, 0.0);
	    rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
	    				
		rmAddObjectDefConstraint(nugget2, nuggetFarConstraint);
		rmAddObjectDefConstraint(nugget2, avoidAll);
		rmAddObjectDefConstraint(nugget2, Southward);
		rmAddObjectDefConstraint(nugget2, forestConstraint);
		rmAddObjectDefConstraint(nugget2, goldConstraint);
		rmAddObjectDefConstraint(nugget2, avoidSocket);
		rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
	    rmAddObjectDefConstraint(nugget2, ridgeConstraint);
	    rmAddObjectDefConstraint(nugget2, nativesConstraint);
        rmAddObjectDefConstraint(nugget2, playerConstraint);
		rmAddObjectDefConstraint(nugget2, playerEdgeConstraint);
		rmAddObjectDefConstraint(nugget2, avoidKOTH);
		rmAddObjectDefConstraint(nugget2, impassableLandConstraint);
		   
		if (cNumberNonGaiaPlayers <=2)
	{	
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);
	}
        else
	{
        rmPlaceObjectDefAtLoc(nugget2, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.925);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/

        // YPIBEX CONSTRAINTS:
	    //int ypIbexConstraint=rmCreateTypeDistanceConstraint("stuff vs ypIbex", "ypIbex", 15.0);
		//int ypIbexMediumConstraint=rmCreateTypeDistanceConstraint("medium vs ypIbex", "ypIbex", 25.0);
	    //int ypIbexFarConstraint=rmCreateTypeDistanceConstraint("far vs ypIbex", "ypIbex", 65.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
	    		
		// THE NORTHERN YPIBEX HERDS:
        int ypIbexID=rmCreateObjectDef("The Northern YpIbex Herds");
	    rmAddObjectDefItem(ypIbexID, "ypIbex", rmRandInt(7,9), 6.0);
	    rmSetObjectDefMinDistance(ypIbexID, 0.0);
	    rmSetObjectDefMaxDistance(ypIbexID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(ypIbexID, ypIbexFarConstraint);
		rmAddObjectDefConstraint(ypIbexID, goldConstraint);
		rmAddObjectDefConstraint(ypIbexID, avoidAll);
		rmAddObjectDefConstraint(ypIbexID, forestConstraint);
		rmAddObjectDefConstraint(ypIbexID, avoidTradeRoute);
		rmAddObjectDefConstraint(ypIbexID, avoidSocket);
	    rmAddObjectDefConstraint(ypIbexID, nativesConstraint);
		rmAddObjectDefConstraint(ypIbexID, nuggetConstraint);
		rmAddObjectDefConstraint(ypIbexID, playerConstraint);
		rmAddObjectDefConstraint(ypIbexID, playerEdgeConstraint);
		rmAddObjectDefConstraint(ypIbexID, ridgeConstraint);
		rmAddObjectDefConstraint(ypIbexID, Northward);
		rmAddObjectDefConstraint(ypIbexID, avoidKOTH);
		rmAddObjectDefConstraint(ypIbexID, impassableLandConstraint);
			
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(ypIbexID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(ypIbexID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
    }	
	
/*----------------------------------------------------------------------------------------------------------------*/

	    // THE SOUTHERN YPIBEX HERDS:
        int ypIbex2ID=rmCreateObjectDef("The Southern YpIbex Herds");
	    rmAddObjectDefItem(ypIbex2ID, "ypIbex", rmRandInt(7,9), 6.0);
	    rmSetObjectDefMinDistance(ypIbex2ID, 0.0);
	    rmSetObjectDefMaxDistance(ypIbex2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(ypIbex2ID, ypIbexFarConstraint);
		rmAddObjectDefConstraint(ypIbex2ID, goldConstraint);
		rmAddObjectDefConstraint(ypIbex2ID, avoidAll);
		rmAddObjectDefConstraint(ypIbex2ID, forestConstraint);
		rmAddObjectDefConstraint(ypIbex2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(ypIbex2ID, avoidSocket);
	    rmAddObjectDefConstraint(ypIbex2ID, nativesConstraint);
		rmAddObjectDefConstraint(ypIbex2ID, nuggetConstraint);
		rmAddObjectDefConstraint(ypIbex2ID, playerConstraint);
		rmAddObjectDefConstraint(ypIbex2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(ypIbex2ID, ridgeConstraint);
		rmAddObjectDefConstraint(ypIbex2ID, Southward);
		rmAddObjectDefConstraint(ypIbex2ID, avoidKOTH);
		rmAddObjectDefConstraint(ypIbex2ID, impassableLandConstraint);
			
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(ypIbex2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(ypIbex2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
    }
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE BERRIES: **************************************** //        
/*================================================================================================================*/

		// FRUITS CONSTRAINTS:
	    //int fruitsConstraint=rmCreateTypeDistanceConstraint("the stuff vs fruits", "AbstractFruit", 15.0);
		//int fruitsMediumConstraint=rmCreateTypeDistanceConstraint("the medium vs fruits", "AbstractFruit", 40.0);
	    //int fruitsFarConstraint=rmCreateTypeDistanceConstraint("the far vs fruits", "AbstractFruit", 65.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// THE NORTHERN BERRIES:
		int berriesID=rmCreateObjectDef("The Northern Berries");
	    rmAddObjectDefItem(berriesID, "berrybush", rmRandInt(5,8), 5.0); 
	    rmSetObjectDefMinDistance(berriesID, 0.0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(berriesID, fruitsFarConstraint);
	    rmAddObjectDefConstraint(berriesID, ypIbexMediumConstraint);
		rmAddObjectDefConstraint(berriesID, goldConstraint);
		rmAddObjectDefConstraint(berriesID, avoidAll);
		rmAddObjectDefConstraint(berriesID, avoidTradeRoute);
		rmAddObjectDefConstraint(berriesID, avoidSocket);
		rmAddObjectDefConstraint(berriesID, forestConstraint);
		rmAddObjectDefConstraint(berriesID, nativesConstraint);
		rmAddObjectDefConstraint(berriesID, nuggetConstraint);
		rmAddObjectDefConstraint(berriesID, playerConstraint);
		rmAddObjectDefConstraint(berriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(berriesID, ridgeConstraint);
		rmAddObjectDefConstraint(berriesID, Northward);
		rmAddObjectDefConstraint(berriesID, avoidKOTH);
		rmAddObjectDefConstraint(berriesID, impassableLandConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(berriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
    }
	
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BERRIES:
		int berries2ID=rmCreateObjectDef("The Southern Berries");
	    rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(5,8), 5.0); 
	    rmSetObjectDefMinDistance(berries2ID, 0.0);
	    rmSetObjectDefMaxDistance(berries2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(berries2ID, fruitsFarConstraint);
	    rmAddObjectDefConstraint(berries2ID, ypIbexMediumConstraint);
		rmAddObjectDefConstraint(berries2ID, goldConstraint);
		rmAddObjectDefConstraint(berries2ID, avoidAll);
		rmAddObjectDefConstraint(berries2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(berries2ID, avoidSocket);
		rmAddObjectDefConstraint(berries2ID, forestConstraint);
		rmAddObjectDefConstraint(berries2ID, nativesConstraint);
		rmAddObjectDefConstraint(berries2ID, nuggetConstraint);
		rmAddObjectDefConstraint(berries2ID, playerConstraint);
		rmAddObjectDefConstraint(berries2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(berries2ID, ridgeConstraint);
		rmAddObjectDefConstraint(berries2ID, Southward);
		rmAddObjectDefConstraint(berries2ID, avoidKOTH);
		rmAddObjectDefConstraint(berries2ID, impassableLandConstraint);
		
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
    }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.975);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE YPYAK HERDS: ************************************** //
/*================================================================================================================*/

        // YPIBEX CONSTRAINTS:
	    int ypYakConstraint=rmCreateTypeDistanceConstraint("stuff vs ypYak", "ypYak", 15.0);
		int ypYakMediumConstraint=rmCreateTypeDistanceConstraint("medium vs ypYak", "ypYak", 25.0);
	    int ypYakFarConstraint=rmCreateTypeDistanceConstraint("far vs ypYak", "ypYak", 65.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		
	    		
		// THE NORTHERN YPYAK HERDS:
        int ypYakID=rmCreateObjectDef("The Northern ypYak Herds");
	    rmAddObjectDefItem(ypYakID, "ypYak", rmRandInt(7,9), 6.0);
	    rmSetObjectDefMinDistance(ypYakID, 0.0);
	    rmSetObjectDefMaxDistance(ypYakID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(ypYakID, ypYakFarConstraint);
		rmAddObjectDefConstraint(ypYakID, ypIbexMediumConstraint);
		rmAddObjectDefConstraint(ypYakID, goldConstraint);
		rmAddObjectDefConstraint(ypYakID, avoidAll);
		rmAddObjectDefConstraint(ypYakID, forestConstraint);
		rmAddObjectDefConstraint(ypYakID, avoidTradeRoute);
		rmAddObjectDefConstraint(ypYakID, avoidSocket);
	    rmAddObjectDefConstraint(ypYakID, nativesConstraint);
		rmAddObjectDefConstraint(ypYakID, nuggetConstraint);
		rmAddObjectDefConstraint(ypYakID, playerConstraint);
		rmAddObjectDefConstraint(ypYakID, playerEdgeConstraint);
		rmAddObjectDefConstraint(ypYakID, ridgeConstraint);
		rmAddObjectDefConstraint(ypYakID, Northward);
		rmAddObjectDefConstraint(ypYakID, avoidKOTH);
		rmAddObjectDefConstraint(ypYakID, impassableLandConstraint);
		rmAddObjectDefConstraint(ypYakID, fruitsMediumConstraint);
	    
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(ypYakID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(ypYakID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
    }
	
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN YPYAK HERDS:
        int ypYak2ID=rmCreateObjectDef("The Southern ypYak Herds");
	    rmAddObjectDefItem(ypYak2ID, "ypYak", rmRandInt(7,9), 6.0);
	    rmSetObjectDefMinDistance(ypYak2ID, 0.0);
	    rmSetObjectDefMaxDistance(ypYak2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(ypYak2ID, ypYakFarConstraint);
		rmAddObjectDefConstraint(ypYak2ID, ypIbexMediumConstraint);
		rmAddObjectDefConstraint(ypYak2ID, goldConstraint);
		rmAddObjectDefConstraint(ypYak2ID, avoidAll);
		rmAddObjectDefConstraint(ypYak2ID, forestConstraint);
		rmAddObjectDefConstraint(ypYak2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(ypYak2ID, avoidSocket);
	    rmAddObjectDefConstraint(ypYak2ID, nativesConstraint);
		rmAddObjectDefConstraint(ypYak2ID, nuggetConstraint);
		rmAddObjectDefConstraint(ypYak2ID, playerConstraint);
		rmAddObjectDefConstraint(ypYak2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(ypYak2ID, ridgeConstraint);
		rmAddObjectDefConstraint(ypYak2ID, Southward);
		rmAddObjectDefConstraint(ypYak2ID, avoidKOTH);
		rmAddObjectDefConstraint(ypYak2ID, impassableLandConstraint);
		rmAddObjectDefConstraint(ypYak2ID, fruitsMediumConstraint);
	    
		if (cNumberNonGaiaPlayers <=2)
	{	
	    rmPlaceObjectDefAtLoc(ypYak2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);  
    } 
	    else
	{	
	    rmPlaceObjectDefAtLoc(ypYak2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);
    }

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.985);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //  
/*================================================================================================================*/
  
        // FISH CONSTRAINTS:
        int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "AbstractFish", 15.0);	
	    int fish2VsFish2ID=rmCreateTypeDistanceConstraint("fish2 v fish2", "AbstractFish", 15.0); 
	    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/
	 
        // THE WESTERN FISHES:
		int fishID=rmCreateObjectDef("fish 1");
        rmAddObjectDefItem(fishID, fish1, 2, 5.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
		rmAddObjectDefConstraint(fishID, Westward);
		
		if (cNumberNonGaiaPlayers <=2)
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 16*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN FISHES:
		int fish2ID=rmCreateObjectDef("fish 2");
        rmAddObjectDefItem(fish2ID, fish2, 2, 5.0);
        rmSetObjectDefMinDistance(fish2ID, 0.0);
        rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fish2ID, fish2VsFish2ID);
        rmAddObjectDefConstraint(fish2ID, fishLand);
		rmAddObjectDefConstraint(fish2ID, Eastward);
		
		if (cNumberNonGaiaPlayers <=2)
        rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 16*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.995);
/*================================================================================================================*/
// ***************************************** STARTER SHIPMENT TRIGGERS: ***************************************** //
/*================================================================================================================*/

        for(i = 1; < cNumberPlayers) 
  {
        rmCreateTrigger("XP"+i);
        rmSwitchToTrigger(rmTriggerID("XP"+i));
        rmSetTriggerPriority(3); 
        rmSetTriggerActive(true);
        rmSetTriggerRunImmediately(true);
        rmSetTriggerLoop(false);
      
        rmAddTriggerCondition("Always");
    
        rmAddTriggerEffect("Grant Resources");
        rmSetTriggerEffectParamInt("PlayerID", i, false);
        rmSetTriggerEffectParam("ResName", "XP", false);
        rmSetTriggerEffectParam("Amount", "275", false);
  }	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/    
